#include <stdio.h>
#include <math.h>
#include "structures.h"
#include "file.h"
#include "mem_alloc.h"
#include "plot.h"
#include "grid.h"

#define defC 0.999
 

int main(void)
{
    int    ngrid1,magnetic1,getname,open_ok,nrings,j,ngrid2,magnetic2;
    float  inc1,*Cq1,*Cm1,*Br1,*Bp1,*Bt1,inc2,*Cq2,*Cm2,*Br2,*Bp2,*Bt2,
           alf,bet,ve1,ve2; 
    char   filename[80],com[120]; 

    getname = 1;
    do { 
        open_ok = read_bright(&ngrid1,&Cq1,&Cm1,&Br1,&Bt1,&Bp1,filename,
                              getname,com,&inc1,&ve1,&magnetic1);
        printf("%s\n", filename); 
        if (open_ok == 1) printf("File not found, try again.\n");
    } while (open_ok == 1); 

    do { 
        open_ok = read_bright(&ngrid2,&Cq2,&Cm2,&Br2,&Bt2,&Bp2,filename,
                              getname,com,&inc2,&ve2,&magnetic2);
        printf("%s\n", filename); 
        if (open_ok == 1) printf("File not found, try again.\n");
    } while (open_ok == 1); 

    if (ngrid1 != ngrid2) {
        printf("Incompatible images\n"); 
        exit(1); 
    } else {
        printf("Coefficients : "); 
        scanf("%f %f", &alf, &bet); 
        for (j = 0; j < ngrid1; j++) {
            Cq1[j] = alf*Cq1[j] + bet*Cq2[j]; 
            if (magnetic1*magnetic2) {
                Cm1[j] = alf*Cm1[j] + bet*Cm2[j]; 
                Br1[j] = alf*Br1[j] + bet*Br2[j]; 
                Bp1[j] = alf*Bp1[j] + bet*Bp2[j]; 
                Bt1[j] = alf*Bt1[j] + bet*Bt2[j]; 
            }
        }
    }
    save_bright(ngrid1,Cq1,Cm1,Br1,Bt1,Bp1,filename,1,com,inc1,ve1,magnetic1);

    free_vector(Cq1,0,ngrid1-1);
    if (magnetic1 == 1) {
        free_vector(Cm1,0,ngrid1-1);
        free_vector(Br1,0,ngrid1-1);
        free_vector(Bp1,0,ngrid1-1);
        free_vector(Bt1,0,ngrid1-1);
    }
    free_vector(Cq2,0,ngrid2-1);
    if (magnetic2 == 1) {
        free_vector(Cm2,0,ngrid2-1);
        free_vector(Br2,0,ngrid2-1);
        free_vector(Bp2,0,ngrid2-1);
        free_vector(Bt2,0,ngrid2-1);
    }
} 
