void init_spectral_lines(int batch);

void end_spectral_lines(void);

void get_spectral_lines(int *nlines, char **names[], int **ids);

void line_info(int id, double *l0, double *dl, int *broadened, int *linear);

double find_line_centre(int id);

double find_macro_turb(int id);

void line_profile(int id, float I[], float Q[], float U[], float V[],
		  int n, double lambda[], double Cq, double Cm,
                  double mu, double B, double gam, double chi, int magnetic);

void line_deriv(int id, float **dI, float **dQ, float **dU, float **dV, 
                float I[], float Q[], float U[], float V[],
		int n, double lambda[],
                double Cq, double Cm, double mu,
                double B, double gam, double chi, int magnetic);

void continuum(int id, double mu, double Cq, double Cm, float *cont,
				float *dCq, float *dCm, int magnetic);

void image_info(int *Cm_used, char *qnames[], int *ff_entropy, int *ff_rec, int batch);

void image_defaults(float *dCq, float *dB, int magnetic, int Cm_used, 
                   char *qnames[], int batch); 
void transform(float Cq[], float Cm[], int ngrid, int magnetic);

void untransform(float Cq[], float Cm[], int ngrid, int magnetic);


