#include <stdio.h>
#include <math.h>
#include "structures.h"
#include "grid.h"
#include "file.h"
#include "mem_alloc.h"
 

int main(void)
{
    int    ngrid1,magnetic1,getname,open_ok,i,j,n,npt;
    float  inc1,ve1,*Cq1,*Cm1,*Br1,*Bp1,*Bt1,theta,phi,*pt1,latl,latu,lonl,lonu; 
    char   filename[80],com[120],answer[2];
    FILE *fp; 

    getname = 1;
    do { 
        open_ok = read_bright(&ngrid1,&Cq1,&Cm1,&Br1,&Bt1,&Bp1,filename,
                              getname,com,&inc1,&ve1,&magnetic1);
        printf("%s\n", filename); 
        if (open_ok == 1) printf("File not found, try again.\n");
    } while (open_ok == 1); 
    init_grid(ngrid1, inc1, ve1); 

        do {
            printf("Quantity to cross correlate (any of qmrpt) : ");
            scanf("%1s", answer);
            if (answer[0] == 'q')      pt1 = Cq1; 
            else if (answer[0] == 'm') pt1 = Cm1;
            else if (answer[0] == 'r') pt1 = Br1;
            else if (answer[0] == 'p') pt1 = Bp1; 
            else if (answer[0] == 't') pt1 = Bt1; 
            else {
                printf("Choose any parameter among qmrpt\n");
                open_ok = 1;
            }
        } while (open_ok);
    if (!magnetic1) pt1 = Cq1; 


    npt = 180; 
    printf("Phase range : "); 
    scanf("%f %f", &lonl, &lonu); 
    printf("Latitude range : "); 
    scanf("%f %f", &latl, &latu); 

    printf("File to save data to: ");
    scanf("%s", filename);
    fp = fopen(filename, "w");
    fprintf(fp,"%d %d \n %.2f %.2f \n %.2f %.2f \n", 2*npt,npt, lonu, lonl, latl, latu);

    lonl *= 2.0*3.1415926; lonu *= 2.0*3.1415926; 
    latl *= 3.1415926/180.0; latu *= 3.1415926/180.0; 
    for (i = 0; i < npt; i++) { 
        theta = latl + (i+0.5)*(latu-latl)/npt; 
        for (j = 0; j < 2*npt; j++) { 
            phi = lonl + (j+0.5)*(lonu-lonl)/npt/2; 
            find_grid_loc(theta,phi,&n,0.0); 
            if ((n > 0) && (n <= ngrid1)) {
                n--; 
                fprintf(fp, "%9.6f ", pt1[n]);
                if (j%10 == 9) fprintf(fp, "\n");
            } else { 
                fprintf(fp, " 0.000000 ");
                if (j%10 == 9) fprintf(fp, "\n");
            } 
        }  
        if (j%10 != 0) printf(fp, "\n");
    }
    fclose(fp);
 
    free_vector(Cq1,0,ngrid1-1);
    if (magnetic1 == 1) {
        free_vector(Cm1,0,ngrid1-1);
        free_vector(Br1,0,ngrid1-1);
        free_vector(Bp1,0,ngrid1-1);
        free_vector(Bt1,0,ngrid1-1);
    }
} 
