#include <stdio.h>
#include <math.h>
#include "structures.h"
#include "grid.h"
#include "file.h"
#include "mem_alloc.h"
 

int main(void)
{
    int    ngrid1,magnetic1,getname,open_ok,i,j,n,npt,ngrid2,magnetic2;
    float  inc1,ve1,*Cq1,*Cm1,*Br1,*Bp1,*Bt1,theta,phi,*pt1,latl,latu,lonl,lonu; 
    float  inc2,ve2,*Cq2,*Cm2,*Br2,*Bp2,*Bt2,*pt2,sign,tmp,tmp2; 
    char   filename[80],com[120],answer[2];
    FILE *fp; 

    getname = 1;
    do { 
        open_ok = read_bright(&ngrid1,&Cq1,&Cm1,&Br1,&Bt1,&Bp1,filename,
                              getname,com,&inc1,&ve1,&magnetic1);
        printf("%s\n", filename); 
        if (open_ok == 1) printf("File not found, try again.\n");
    } while (open_ok == 1); 
    init_grid(ngrid1, inc1, ve1); 
/*
    do {
        open_ok = read_bright(&ngrid2,&Cq2,&Cm2,&Br2,&Bt2,&Bp2,filename,
                              getname,com,&inc2,&ve2,&magnetic2);
        printf("%s\n", filename);
        if (open_ok == 1) printf("File not found, try again\n");
        if ((ngrid2 != ngrid1) || (inc2 != inc1)) {
            printf("Incompatible file, try again\n");
            open_ok = 1;
            free_vector(Cq2,0,ngrid2-1);
            if (magnetic2 == 1) {
                free_vector(Cm2,0,ngrid2-1);
                free_vector(Br2,0,ngrid2-1);
                free_vector(Bp2,0,ngrid2-1);
                free_vector(Bt2,0,ngrid2-1);
            }
        }
    } while (open_ok == 1);
*/

        do {
            printf("Quantity to cross correlate (any of qmrpt) : ");
            scanf("%1s", answer);
            if (answer[0] == 'q')      pt1 = Cq1; 
            else if (answer[0] == 'm') pt1 = Cm1;
            else if (answer[0] == 'r') pt1 = Br1;
            else if (answer[0] == 'p') pt1 = Bp1; 
            else if (answer[0] == 't') pt1 = Bt1; 
            else {
                printf("Choose any parameter among qmrpt\n");
                open_ok = 1;
            }
        } while (open_ok);
    if (!magnetic1) pt1 = Cq1; 

    npt = 180; 
/*
    printf("Phase range : "); 
    scanf("%f %f", &lonl, &lonu); 
    printf("Latitude range : "); 
    scanf("%f %f", &latl, &latu); 
*/
lonl = 0.0; lonu = 1.0; 
latl = -90.0; latu = 90.0; 

    lonl *= 2.0*3.1415926; lonu *= 2.0*3.1415926; 
    latl *= 3.1415926/180.0; latu *= 3.1415926/180.0; 
printf("%d %d\n", 2*npt, npt); 
sign = 1.0; 
    for (i = 0; i < npt; i++) { 
        theta = latl + (npt-i-0.5)*(latu-latl)/npt; 
/*
if (theta < 0.0) { theta *= -1.0; sign = -1.0;}
else sign = 1.0; 
*/
        for (j = 0; j < 2*npt; j++) { 
            phi = lonl + (j+0.5)*(lonu-lonl)/npt/2; 
            find_grid_loc(theta,phi,&n,0.0); 
            if ((n > 0) && (n <= ngrid1)) {
                n--; 
/*
printf("%9.3f ", tmp2 = sign*pt1[n]/(pt2[n] + 0.13*(1.0-pt2[n])));
*/
printf("%9.3f ", tmp2 = sign*pt1[n]);
if (j%8 == 7) printf("\n");
            } else { 
printf("    1.000 ");
if (j%8 == 7) printf("\n");
            } 
        }  
    }
 
    free_vector(Cq1,0,ngrid1-1);
    if (magnetic1 == 1) {
        free_vector(Cm1,0,ngrid1-1);
        free_vector(Br1,0,ngrid1-1);
        free_vector(Bp1,0,ngrid1-1);
        free_vector(Bt1,0,ngrid1-1);
    }
/*
    free_vector(Cq2,0,ngrid2-1);
    if (magnetic2 == 1) {
        free_vector(Cm2,0,ngrid2-1);
        free_vector(Br2,0,ngrid2-1);
        free_vector(Bp2,0,ngrid2-1);
        free_vector(Bt2,0,ngrid2-1);
    }
*/
} 
