#include <stdio.h>
#include <math.h>
#include "structures.h"
#include "grid.h"
#include "file.h"
#include "mem_alloc.h"
 
void change_coord(float *phi, float *theta, float *phi2, float *theta2, int ngrid, float alpha); 


int main(void)
{
    int    ngrid1,magnetic1,getname,open_ok,j,n;
    float  inc1,ve1,*Cq1,*Cm1,*Br1,*Bp1,*Bt1,*Cq2,*Cm2,*Br2,*Bp2,*Bt2,*theta,*phi,phase,lat,
           *phi2,*theta2,Bx,By,Bz,tmp; 
    char   filename[80],com[120],answer[2];

    getname = 1;
    do { 
        open_ok = read_bright(&ngrid1,&Cq1,&Cm1,&Br1,&Bt1,&Bp1,filename,
                              getname,com,&inc1,&ve1,&magnetic1);
        printf("%s\n", filename); 
        if (open_ok == 1) printf("File not found, try again.\n");
        if (!magnetic1) { 
            printf("Wrong image, try again.\n");
            open_ok = 1; 
        } 
    } while (open_ok == 1); 
    init_grid(ngrid1, inc1, ve1);

    printf("Phase and latitude of magnetic pole : "); 
    scanf("%f %f", &phase, &lat);  printf("%f %f\n", phase, lat); 
    lat = (90.0-lat)*3.1415926/180.0; 

    phi    =  vector(0, ngrid1-1);
    theta  =  vector(0, ngrid1-1);
    phi2   =  vector(0, ngrid1-1);
    theta2 =  vector(0, ngrid1-1);
    Cq2 =  vector(0, ngrid1-1);
    Cm2 =  vector(0, ngrid1-1);
    Br2 =  vector(0, ngrid1-1);
    Bp2 =  vector(0, ngrid1-1);
    Bt2 =  vector(0, ngrid1-1);

    locations(phase,ngrid1,theta2,phi2);
    change_coord(phi2,theta2,phi,theta,ngrid1,-lat); 

    for (j = 0; j < ngrid1; j++) { 
        find_grid_loc(theta[j],phi[j],&n,phase); 
        if (n == 0) { 
            Cq2[j] = 1.0; Cm2[j] = Br2[j] = Bp2[j] = Bt2[j] = 0.0; 
        } else { 

/* Change to cartesian coordinates */ 
            Bx = -Bt1[n-1]*sin(phi[j]) - Bp1[n-1]*sin(theta[j])*cos(phi[j]); 
            By =  Bt1[n-1]*cos(phi[j]) - Bp1[n-1]*sin(theta[j])*sin(phi[j]); 
            Bz =                         Bp1[n-1]*cos(theta[j]); 

/* Rotate about y axis to switch from rotational to magnetic pole */ 
            tmp = Bx*cos(lat) - Bz*sin(lat); 
            Bz  = Bx*sin(lat) + Bz*cos(lat);
            Bx  = tmp; 

/* Switch back to new spherical coordinates */ 
            Br2[j] =   Br1[n-1]; 
            Bp2[j] = -(Bx*cos(phi2[j]) + By*sin(phi2[j])) * sin(theta2[j]) + Bz*cos(theta2[j]); 
            Bt2[j] =  -Bx*sin(phi2[j]) + By*cos(phi2[j]); 
        } 
    } 
 
    save_bright(ngrid1,Cq2,Cm2,Br2,Bt2,Bp2,filename,1,com,inc1,ve1,magnetic1);

    free_vector(Cq1,0,ngrid1-1);
    free_vector(Cq2,0,ngrid1-1);
    if (magnetic1 == 1) {
        free_vector(Cm1,0,ngrid1-1);
        free_vector(Br1,0,ngrid1-1);
        free_vector(Bp1,0,ngrid1-1);
        free_vector(Bt1,0,ngrid1-1);
        free_vector(Cm2,0,ngrid1-1);
        free_vector(Br2,0,ngrid1-1);
        free_vector(Bp2,0,ngrid1-1);
        free_vector(Bt2,0,ngrid1-1);
    }
} 


void change_coord(float *phi, float *theta, float *phi2, float *theta2, int ngrid, float alpha)
{
    int   j; 
    float x, y, z, PI; 

    PI = 3.1415926; 
    for (j = 0; j < ngrid; j++) { 

        x = cos(phi[j])*cos(theta[j])*cos(alpha) - sin(theta[j])*sin(alpha); 
        y = sin(phi[j])*cos(theta[j]); 
        z = cos(phi[j])*cos(theta[j])*sin(alpha) + sin(theta[j])*cos(alpha); 

        if (x == 0.0) { 
            if (y < 0) phi2[j] = -0.5*PI; 
            else       phi2[j] =  0.5*PI; 
        } else { 
            phi2[j] = atan(y/x); 
            if (x < 0.0) { 
                if (y > 0.0) phi2[j] += PI; 
                else         phi2[j] -= PI; 
            } 
        } 

        theta2[j] = asin(z); 
        if (theta2[j] > 0.5*PI) { 
            theta2[j] =  PI - theta2[j]; 
            if (phi2[j] <= 0.0) phi2[j] += PI; 
            else                phi2[j] -= PI;
        } else if (theta2[j] < -0.5*PI) {
            theta2[j] = -PI - theta2[j]; 
            if (phi2[j] <= 0.0) phi2[j] += PI; 
            else                phi2[j] -= PI;
        } 
    } 
}
