#include <stdio.h>
#include <math.h>
#include "structures.h"
#include "constants.h"
#include "grid.h"
#include "file.h"
#include "mem_alloc.h"
 
int main(void)
{
    int    ngrid1,magnetic1,getname,open_ok,j,n;
    float  inc1,ve1,*Cq1,*Cm1,*Br1,*Bp1,*Bt1,*Cq2,*Cm2,*Br2,*Bp2,*Bt2,*theta,*phi,phase,lat,
           *phi2,*theta2,Bx,By,Bz,tmp; 
    char   filename[80],com[120],answer[2];

    getname = 1;
    do { 
        open_ok = read_bright(&ngrid1,&Cq1,&Cm1,&Br1,&Bt1,&Bp1,filename,
                              getname,com,&inc1,&ve1,&magnetic1);
        printf("%s\n", filename); 
        if (open_ok == 1) printf("File not found, try again.\n");
        if (!magnetic1) { 
            printf("Wrong image, try again.\n");
            open_ok = 1; 
        } 
    } while (open_ok == 1); 
    init_grid(ngrid1, inc1, ve1);

    phi    =  vector(0, ngrid1-1);
    theta  =  vector(0, ngrid1-1);
    phi2   =  vector(0, ngrid1-1);
    theta2 =  vector(0, ngrid1-1);
    Cq2 =  vector(0, ngrid1-1);
    Cm2 =  vector(0, ngrid1-1);
    Br2 =  vector(0, ngrid1-1);
    Bp2 =  vector(0, ngrid1-1);
    Bt2 =  vector(0, ngrid1-1);

    locations(0.0,ngrid1,theta,phi);

    for (j = 0; j < ngrid1; j++) { 
        if (theta[j] < 0.0) { 
            Cq2[j] = 1.00; 
        } else { 
            if (Cq1[j] > 0.5) Cq2[j] = 1.0; 
            else              Cq2[j] = 0.0; 
        } 
        Br1[j] = Bp1[j] = Bt1[j] = 0.0; 
    } 
 
    save_bright(ngrid1,Cq2,Cm1,Br1,Bt1,Bp1,filename,1,com,inc1,ve1,magnetic1);

    free_vector(Cq1,0,ngrid1-1);
    free_vector(Cq2,0,ngrid1-1);
    if (magnetic1 == 1) {
        free_vector(Cm1,0,ngrid1-1);
        free_vector(Br1,0,ngrid1-1);
        free_vector(Bp1,0,ngrid1-1);
        free_vector(Bt1,0,ngrid1-1);
        free_vector(Cm2,0,ngrid1-1);
        free_vector(Br2,0,ngrid1-1);
        free_vector(Bp2,0,ngrid1-1);
        free_vector(Bt2,0,ngrid1-1);
    }
} 


